/*

    this source file is a part of 
    lp_parse - a preprocessor for MILP models
    Copyright (C) 1996  Ari Jolma

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    for more information please contact 
    Ari Jolma
    Helsinki University of Technology
    Laboratory of Water Resources Engineering
    Building W
    02150 Espoo, Finland
    E-mail: Ari.Jolma@hut.fi

 */

unsigned int HashPJW ( const char * datum );
unsigned long ElfHash ( const unsigned char *name );

int ATJHash(const char *name );

struct hash_entry {
  void *next;
  char *name;
};

#define HASH_ENTRY struct hash_entry

void insert_hash_entry(HASH_ENTRY *hash_entry,
		       HASH_ENTRY *hash_table[], 
		       int hash_key);

HASH_ENTRY *search_hash_entry(char *name,
			      HASH_ENTRY *hash_table[], 
			      int hash_key);
